Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/CorePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/CorePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.Core/3.2/CorePlugin.cs	(revision 2587)
@@ -27,13 +27,13 @@
 
 namespace HeuristicLab.Hive.Client.Core {
-  [ClassInfo(Name = "HeuristicLab.Hive.Client.Core-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Client.Core-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAccess-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Client.Common-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Client.Communication-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Client.ExecutionEngine-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Contracts-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.JobBase-3.2")]
+  [Plugin("HeuristicLab.Hive.Client.Core-3.2")]
+  [PluginFile("HeuristicLab.Hive.Client.Core-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.DataAccess-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Client.Common-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Client.Communication-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Client.ExecutionEngine-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
+  [PluginDependency("HeuristicLab.Hive.JobBase-3.2")]
   public class CorePlugin: PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.ExecutionEngine/3.2/ExecutionEnginePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.ExecutionEngine/3.2/ExecutionEnginePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Client.ExecutionEngine/3.2/ExecutionEnginePlugin.cs	(revision 2587)
@@ -27,11 +27,11 @@
 
 namespace HeuristicLab.Hive.Client.ExecutionEngine {
-  [ClassInfo(Name = "HeuristicLab.Hive.Client.ExecutionEngine-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Client.ExecutionEngine-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Client.Common-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Client.Communication-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Contracts-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.JobBase-3.2")] 
+  [Plugin("HeuristicLab.Hive.Client.ExecutionEngine-3.2")]
+  [PluginFile("HeuristicLab.Hive.Client.ExecutionEngine-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Client.Common-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Client.Communication-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
+  [PluginDependency("HeuristicLab.Hive.JobBase-3.2")] 
   public class ExecutionEnginePlugin: PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Contracts/3.2/HiveContractPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Contracts/3.2/HiveContractPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Contracts/3.2/HiveContractPlugin.cs	(revision 2587)
@@ -26,8 +26,8 @@
 
 namespace HeuristicLab.Hive.Server {
-  [ClassInfo(Name = "HeuristicLab.Hive.Contracts-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Contracts-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAccess-3.2")]
+  [Plugin("HeuristicLab.Hive.Contracts-3.2")]
+  [PluginFile("HeuristicLab.Hive.Contracts-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.DataAccess-3.2")]
   public class HiveServerContracts : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Engine/3.2/HeuristicLabHiveEnginePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Engine/3.2/HeuristicLabHiveEnginePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Engine/3.2/HeuristicLabHiveEnginePlugin.cs	(revision 2587)
@@ -29,14 +29,14 @@
   /// Plugin class for HeuristicLab.Hive.Engine plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.Hive.Engine-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Engine-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Common-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAccess-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Contracts-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.JobBase-3.2")]
-  [Dependency(Dependency = "HeuristicLab.SequentialEngine-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Tracing-3.2")]
+  [Plugin("HeuristicLab.Hive.Engine-3.2")]
+  [PluginFile("HeuristicLab.Hive.Engine-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.DataAccess-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
+  [PluginDependency("HeuristicLab.Hive.JobBase-3.2")]
+  [PluginDependency("HeuristicLab.SequentialEngine-3.2")]
+  [PluginDependency("HeuristicLab.Tracing-3.2")]
   public class HeuristicLabHiveEnginePlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Engine/3.2/HiveEngine.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Engine/3.2/HiveEngine.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Engine/3.2/HiveEngine.cs	(revision 2587)
@@ -125,5 +125,5 @@
 
         job = restoredJob;
-        PluginManager.ControlManager.ShowControl(job.Engine.CreateView());
+        ControlManager.Manager.ShowControl(job.Engine.CreateView());
         OnChanged();
         OnFinished();
@@ -168,5 +168,5 @@
         HiveLogger.Debug("HiveEngine: Results-polling - Got result!");
         job = (Job)PersistenceManager.RestoreFromGZip(jobResult.SerializedJobResultData);
-        PluginManager.ControlManager.ShowControl(job.Engine.CreateView());
+        ControlManager.Manager.ShowControl(job.Engine.CreateView());
       }
       //HiveLogger.Debug("HiveEngine: Results-polling - Exception!");
@@ -218,9 +218,8 @@
       executableJobObj.SerializedJobData = memStream.ToArray();
 
-      DiscoveryService service = new DiscoveryService();
-      List<PluginInfo> plugins = new List<PluginInfo>();
+      List<IPluginDescription> plugins = new List<IPluginDescription>();
 
       foreach (IStorable storeable in dictionary.Values) {
-        PluginInfo pluginInfo = service.GetDeclaringPlugin(storeable.GetType());
+        IPluginDescription pluginInfo = ApplicationManager.Manager.GetDeclaringPlugin(storeable.GetType());
         if (!plugins.Contains(pluginInfo)) {
           plugins.Add(pluginInfo);
@@ -233,5 +232,5 @@
       List<HivePluginInfo> pluginsNeeded =
         new List<HivePluginInfo>();
-      foreach (PluginInfo uniquePlugin in plugins) {
+      foreach (IPluginDescription uniquePlugin in plugins) {
         HivePluginInfo pluginInfo =
           new HivePluginInfo();
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.JobBase/3.2/JobPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.JobBase/3.2/JobPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.JobBase/3.2/JobPlugin.cs	(revision 2587)
@@ -6,7 +6,7 @@
 
 namespace HeuristicLab.Hive.JobBase {
-  [ClassInfo(Name = "HeuristicLab.Hive.JobBase-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.JobBase-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Plugin("HeuristicLab.Hive.JobBase-3.2")]
+  [PluginFile("HeuristicLab.Hive.JobBase-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
   public class JobBasePlugin: PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.ADODataAccess/3.2/HiveServerADODataAccessPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.ADODataAccess/3.2/HiveServerADODataAccessPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.ADODataAccess/3.2/HiveServerADODataAccessPlugin.cs	(revision 2587)
@@ -26,8 +26,8 @@
 
 namespace HeuristicLab.Hive.Server.ADODataAccess {
-  [ClassInfo(Name = "HeuristicLab.Hive.Server.ADODataAccess-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Server.ADODataAccess-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Server.Core-3.2")]
+  [Plugin("HeuristicLab.Hive.Server.ADODataAccess-3.2")]
+  [PluginFile("HeuristicLab.Hive.Server.ADODataAccess-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Server.Core-3.2")]
   public class HiveServerADODataAccessPlugin : PluginBase {
 
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsoleApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsoleApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsoleApplication.cs	(revision 2587)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.Hive.Server.ServerConsole {
-  [ClassInfo(Name = "Hive Server Console", Description = "Console Application for the Hive Server.", AutoRestart = true)]
+  [Application("Hive Server Console", "Console Application for the Hive Server.", true)]
   class HiveServerConsoleApplication : ApplicationBase {
     public override void Run() {
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsolePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsolePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Console/3.2/HiveServerConsolePlugin.cs	(revision 2587)
@@ -27,7 +27,7 @@
 
 namespace HeuristicLab.Grid {
-  [ClassInfo(Name = "HeuristicLab.Hive.Server.Console-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Server.Console-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Plugin("HeuristicLab.Hive.Server.Console-3.2")]
+  [PluginFile("HeuristicLab.Hive.Server.Console-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
   public class HeuristicLabHiveClientConsolePlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs	(revision 2587)
@@ -43,8 +43,8 @@
   /// The ClientCommunicator manages the whole communication with the client
   /// </summary>
-  public class ClientCommunicator: IClientCommunicator, 
-    IInternalClientCommunicator{
-    private static Dictionary<Guid, DateTime> lastHeartbeats = 
-      new Dictionary<Guid,DateTime>();
+  public class ClientCommunicator : IClientCommunicator,
+    IInternalClientCommunicator {
+    private static Dictionary<Guid, DateTime> lastHeartbeats =
+      new Dictionary<Guid, DateTime>();
     private static Dictionary<Guid, int> newAssignedJobs =
       new Dictionary<Guid, int>();
@@ -69,11 +69,11 @@
     public ClientCommunicator() {
       factory = ServiceLocator.GetSessionFactory();
-      
+
       lifecycleManager = ServiceLocator.GetLifecycleManager();
-      jobManager = ServiceLocator.GetJobManager() as 
+      jobManager = ServiceLocator.GetJobManager() as
         IInternalJobManager;
       scheduler = ServiceLocator.GetScheduler();
 
-      lifecycleManager.RegisterHeartbeat( 
+      lifecycleManager.RegisterHeartbeat(
         new EventHandler(lifecycleManager_OnServerHeartbeat));
     }
@@ -150,5 +150,5 @@
       }
       catch (Exception ex) {
-        if (tx != null) 
+        if (tx != null)
           tx.Rollback();
         throw ex;
@@ -172,5 +172,5 @@
               pendingJobs[currJob.Id]--;
             }
-          } 
+          }
         }
       }
@@ -365,5 +365,5 @@
       }
     }
-   
+
     /// <summary>
     /// if the client was told to pull a job he calls this method
@@ -489,5 +489,5 @@
           result.ClientId,
           result.JobId,
-          new byte[] {},
+          new byte[] { },
           result.Percentage,
           result.Exception,
@@ -570,5 +570,5 @@
             jobAdapter.GetById(jobId);
         }
-        
+
         if (job == null && job.JobInfo != null) {
           response.Success = false;
@@ -608,5 +608,5 @@
           job.JobInfo.State = State.calculating;
         }
-        if (job.JobInfo.State != State.calculating && 
+        if (job.JobInfo.State != State.calculating &&
           job.JobInfo.State != State.pending) {
           response.Success = false;
@@ -619,5 +619,5 @@
 
         if (finished) {
-          job.JobInfo.State = State.finished; 
+          job.JobInfo.State = State.finished;
         }
 
@@ -676,7 +676,7 @@
     /// <param name="finished"></param>
     /// <returns></returns>
-    public ResponseResultReceived StoreFinishedJobResult(Guid clientId, 
-      Guid jobId, 
-      byte[] result, 
+    public ResponseResultReceived StoreFinishedJobResult(Guid clientId,
+      Guid jobId,
+      byte[] result,
       double percentage,
       Exception exception) {
@@ -802,19 +802,17 @@
     public ResponsePlugin SendPlugins(List<HivePluginInfo> pluginList) {
       ResponsePlugin response = new ResponsePlugin();
-      PluginManager.Manager.Initialize();
-      ICollection<PluginInfo> allActivePlugins = PluginManager.Manager.ActivePlugins;
-
       foreach (HivePluginInfo pluginInfo in pluginList) {
         // TODO: BuildDate deleted, not needed???
         // TODO: Split version to major, minor and revision number
-        foreach (PluginInfo currPlugin in allActivePlugins) {
+        foreach (IPluginDescription currPlugin in ApplicationManager.Manager.Plugins) {
           if (currPlugin.Name == pluginInfo.Name) {
 
-            CachedHivePluginInfo currCachedPlugin = new CachedHivePluginInfo { 
-                Name = currPlugin.Name,
-                Version = currPlugin.Version.ToString(),
-                BuildDate = currPlugin.BuildDate };
-
-            foreach (String assemblyPath in currPlugin.Assemblies) {
+            CachedHivePluginInfo currCachedPlugin = new CachedHivePluginInfo {
+              Name = currPlugin.Name,
+              Version = currPlugin.Version.ToString(),
+              BuildDate = currPlugin.BuildDate
+            };
+
+            foreach (String assemblyPath in currPlugin.Files) {
               currCachedPlugin.PluginFiles.Add(File.ReadAllBytes(assemblyPath));
             }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs	(revision 2587)
@@ -36,7 +36,5 @@
 
 namespace HeuristicLab.Hive.Server {
-  [ClassInfo(Name = "Hive DB Test App",
-      Description = "Test Application for the Hive DataAccess Layer",
-      AutoRestart = true)]
+  [Application("Hive DB Test App", "Test Application for the Hive DataAccess Layer", true)]
   class HiveDbTestApplication : ApplicationBase {
     /*  private void TestClientAdapter() {
@@ -311,6 +309,5 @@
 
       byte[] buffer = new byte[1024];
-      while((length = s.Read(buffer, 0, buffer.Length)) > 0)
-      {
+      while ((length = s.Read(buffer, 0, buffer.Length)) > 0) {
         fs.Write(buffer, 0, length);
       }
@@ -355,10 +352,10 @@
         new ExecutionEngineFacade();
 
-     ResponseObject<SerializedJobResult> response =
-       executionEngineFacade.GetLastSerializedResult(
-       new Guid("56ce20bc-067b-424d-a7df-67aaace7c850"), false);
-
-       IStorable restoredJob =
-         PersistenceManager.RestoreFromGZip(response.Obj.SerializedJobResultData);
+      ResponseObject<SerializedJobResult> response =
+        executionEngineFacade.GetLastSerializedResult(
+        new Guid("56ce20bc-067b-424d-a7df-67aaace7c850"), false);
+
+      IStorable restoredJob =
+        PersistenceManager.RestoreFromGZip(response.Obj.SerializedJobResultData);
     }
 
@@ -369,5 +366,5 @@
       //TestJobResultStreaming();
       TestJobResultDeserialization();
-    }      
+    }
   }
 }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/HiveServerCorePlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/HiveServerCorePlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/HiveServerCorePlugin.cs	(revision 2587)
@@ -26,8 +26,8 @@
 
 namespace HeuristicLab.Hive.Server {
-  [ClassInfo(Name = "HeuristicLab.Hive.Server.Core-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Server.Core-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Contracts-3.2")]
+  [Plugin("HeuristicLab.Hive.Server.Core-3.2")]
+  [PluginFile("HeuristicLab.Hive.Server.Core-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
   public class HiveServerCorePlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/ServiceLocator.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/ServiceLocator.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Core/3.2/ServiceLocator.cs	(revision 2587)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Linq;
 using HeuristicLab.Hive.Server.DataAccess;
 using HeuristicLab.PluginInfrastructure;
@@ -34,7 +35,4 @@
 /// </summary>
 public class ServiceLocator {
-  private static DiscoveryService discoveryService =
-    new DiscoveryService();
-
   private static IClientManager clientManager = null;
 
@@ -109,5 +107,5 @@
     if (sessionFactory == null) {
       sessionFactory = 
-        discoveryService.GetInstances<ISessionFactory>()[0];
+        ApplicationManager.Manager.GetInstances<ISessionFactory>().First();
 
       sessionFactory.DbConnectionType =
@@ -128,5 +126,5 @@
   public static IScheduler GetScheduler() {
     if (scheduler == null) {
-      scheduler = discoveryService.GetInstances<IScheduler>()[0];
+      scheduler = ApplicationManager.Manager.GetInstances<IScheduler>().First();
     }
 
@@ -141,5 +139,5 @@
   public static IPermissionManager GetPermissionManager() {
     if (permManager == null)
-      permManager = discoveryService.GetInstances<IPermissionManager>()[0];
+      permManager = ApplicationManager.Manager.GetInstances<IPermissionManager>().First();
     return permManager;
     
@@ -153,5 +151,5 @@
   public static IHivePermissionManager GetHivePermissionManager() {
     if (hivePermManager == null)
-      hivePermManager = discoveryService.GetInstances<IHivePermissionManager>()[0];
+      hivePermManager = ApplicationManager.Manager.GetInstances<IHivePermissionManager>().First();
     return hivePermManager;
 
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.DataAccess/3.2/HiveServerDataAccessPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.DataAccess/3.2/HiveServerDataAccessPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.DataAccess/3.2/HiveServerDataAccessPlugin.cs	(revision 2587)
@@ -26,8 +26,8 @@
 
 namespace HeuristicLab.Hive.DataAccess {
-  [ClassInfo(Name = "HeuristicLab.Hive.Server.DataAccess-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Server.DataAccess-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Contracts-3.2")]
+  [Plugin("HeuristicLab.Hive.Server.DataAccess-3.2")]
+  [PluginFile("HeuristicLab.Hive.Server.DataAccess-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
   public class HiveServerDataAccessPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Scheduler/3.2/HiveServerSchedulerPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Scheduler/3.2/HiveServerSchedulerPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server.Scheduler/3.2/HiveServerSchedulerPlugin.cs	(revision 2587)
@@ -26,8 +26,8 @@
 
 namespace HeuristicLab.Hive.Server {
-  [ClassInfo(Name = "HeuristicLab.Hive.Server.Scheduler-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Server.Scheduler-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Server-3.2")]
+  [Plugin("HeuristicLab.Hive.Server.Scheduler-3.2")]
+  [PluginFile("HeuristicLab.Hive.Server.Scheduler-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Server-3.2")]
   public class HiveServerSchedulerPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server/3.2/HiveServerApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server/3.2/HiveServerApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server/3.2/HiveServerApplication.cs	(revision 2587)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using System.Text;
+using System.Linq;
 using System.Windows.Forms;
 using HeuristicLab.PluginInfrastructure;
@@ -33,7 +34,5 @@
 
 namespace HeuristicLab.Hive.Server {
-  [ClassInfo(Name = "Hive Server",
-      Description = "Server application for the distributed hive engine.",
-      AutoRestart = true)]
+  [Application("Hive Server", "Server application for the distributed hive engine.", true)]
   public class HiveServerApplication : ApplicationBase {
     public const string STR_ClientCommunicator = "ClientCommunicator";
@@ -41,5 +40,4 @@
     public const string STR_ExecutionEngineFacade = "ExecutionEngineFacade";
 
-    private DiscoveryService discService = new DiscoveryService();
     private Dictionary<string, ServiceHost> runningServices = new Dictionary<string, ServiceHost>();
     private NetTcpBinding binding = (NetTcpBinding)WcfSettings.GetBinding();
@@ -52,5 +50,5 @@
       All
     }
-    
+
     private bool AddMexEndpoint(ServiceHost serviceHost) {
       if (serviceHost != null) {
@@ -69,13 +67,13 @@
       string curServiceHost = "";
       Uri uriTcp;
-      IClientFacade[] clientCommunicatorInstances = discService.GetInstances<IClientFacade>();
-      IServerConsoleFacade[] serverConsoleInstances = discService.GetInstances<IServerConsoleFacade>();
-      IExecutionEngineFacade[] executionEngineInstances = discService.GetInstances<IExecutionEngineFacade>();
+      IEnumerable<IClientFacade> clientCommunicatorInstances = ApplicationManager.Manager.GetInstances<IClientFacade>();
+      IEnumerable<IServerConsoleFacade> serverConsoleInstances = ApplicationManager.Manager.GetInstances<IServerConsoleFacade>();
+      IEnumerable<IExecutionEngineFacade> executionEngineInstances = ApplicationManager.Manager.GetInstances<IExecutionEngineFacade>();
       ServiceHost serviceHost = null;
       switch (svc) {
         case Services.ClientCommunicator:
-          if (clientCommunicatorInstances.Length > 0) {
-            uriTcp = new Uri("net.tcp://" + ipAddress + ":" + port + "/HiveServer/"); 
-            serviceHost = new ServiceHost(clientCommunicatorInstances[0].GetType(), uriTcp);
+          if (clientCommunicatorInstances.Count() > 0) {
+            uriTcp = new Uri("net.tcp://" + ipAddress + ":" + port + "/HiveServer/");
+            serviceHost = new ServiceHost(clientCommunicatorInstances.First().GetType(), uriTcp);
             serviceHost.AddServiceEndpoint(typeof(IClientFacade), streamedBinding, STR_ClientCommunicator);
             curServiceHost = STR_ClientCommunicator;
@@ -83,7 +81,7 @@
           break;
         case Services.ServerConsoleFacade:
-          if (serverConsoleInstances.Length > 0) {
+          if (serverConsoleInstances.Count() > 0) {
             uriTcp = new Uri("net.tcp://" + ipAddress + ":" + port + "/HiveServerConsole/");
-            serviceHost = new ServiceHost(serverConsoleInstances[0].GetType(), uriTcp);
+            serviceHost = new ServiceHost(serverConsoleInstances.First().GetType(), uriTcp);
             serviceHost.AddServiceEndpoint(typeof(IServerConsoleFacade), binding, STR_ServerConsoleFacade);
             curServiceHost = STR_ServerConsoleFacade;
@@ -91,7 +89,7 @@
           break;
         case Services.ExecutionEngineFacade:
-          if (executionEngineInstances.Length > 0) {
+          if (executionEngineInstances.Count() > 0) {
             uriTcp = new Uri("net.tcp://" + ipAddress + ":" + port + "/ExecutionEngine/");
-            serviceHost = new ServiceHost(executionEngineInstances[0].GetType(), uriTcp);
+            serviceHost = new ServiceHost(executionEngineInstances.First().GetType(), uriTcp);
             serviceHost.AddServiceEndpoint(typeof(IExecutionEngineFacade), streamedBinding, STR_ExecutionEngineFacade);
             curServiceHost = STR_ExecutionEngineFacade;
@@ -143,5 +141,5 @@
             break;
       }
-      
+
       //Start services and record their base address
       Dictionary<string, Uri> baseAddrDict = new Dictionary<string, Uri>();
@@ -153,13 +151,13 @@
         StartService(Services.ExecutionEngineFacade, addresses[index], WcfSettings.DEFAULTPORT));
 
-      ILifecycleManager[] lifecycleManagers =  discService.GetInstances<ILifecycleManager>();
-      if (lifecycleManagers.Length > 0) {
+      IEnumerable<ILifecycleManager> lifecycleManagers = ApplicationManager.Manager.GetInstances<ILifecycleManager>();
+      if (lifecycleManagers.Count() > 0) {
         ILifecycleManager lifecycleManager =
-          lifecycleManagers[0];
+          lifecycleManagers.First();
 
         lifecycleManager.Init();
         Form mainForm = new MainForm(baseAddrDict);
         Application.Run(mainForm);
-        
+
         lifecycleManager.Shutdown();
       }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server/3.2/HiveServerPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server/3.2/HiveServerPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Hive.Server/3.2/HiveServerPlugin.cs	(revision 2587)
@@ -27,8 +27,8 @@
 
 namespace HeuristicLab.Hive.Server {
-  [ClassInfo(Name = "HeuristicLab.Hive.Server-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Hive.Server-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Hive.Contracts-3.2")]
+  [Plugin("HeuristicLab.Hive.Server-3.2")]
+  [PluginFile("HeuristicLab.Hive.Server-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
   public class HiveServerPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.IntVector/3.2/HeuristicLabIntVectorPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.IntVector/3.2/HeuristicLabIntVectorPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.IntVector/3.2/HeuristicLabIntVectorPlugin.cs	(revision 2587)
@@ -29,9 +29,9 @@
   /// Plugin class for HeuristicLab.IntVector plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.IntVector-3.2")]
-  [PluginFile(Filename = "HeuristicLab.IntVector-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Evolutionary-3.2")]
+  [Plugin("HeuristicLab.IntVector-3.2")]
+  [PluginFile("HeuristicLab.IntVector-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Evolutionary-3.2")]
   public class HeuristicLabIntVectorPlugin : PluginBase {
   }
